//
//  ComparisonType.swift
//
//
//  Created by Michiel Carman on 1/24/24.
//

import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlComparisonType: Model, Content {
    static let schema = "comparisonType"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Field(key: "name") var name: String?
    @Field(key: "description") var description: String?
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil, name: String? = nil, description: String? = nil, createuserid: Int? = nil, updateuserid: Int? = nil) {
        self.id = id
        
        self.name = name
        self.description = description
        
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}

extension mdlComparisonType{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("comparisonType")
                .field("id", .int, .identifier(auto: true))
                .field("name", .string)
                .field("description", .string)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }

        func revert(on database: Database) async throws {
            try await database.schema("comparisonType").delete()
        }
    }
    struct Seed: Migration{
        func prepare(on database: Database) -> EventLoopFuture<Void> {
            let cts: [mdlComparisonType] = [
                .init(id: 1, name: "Range", description: "must be between a maximum and minimum", createuserid: -1, updateuserid: -1),
                .init(id: 2, name: "Min", description: "must be greater than or equal", createuserid: -1, updateuserid: -1),
                .init(id: 3, name: "Max", description: "must be less than or equal", createuserid: -1, updateuserid: -1),
                .init(id: 4, name: "Equals", description: "must be equal", createuserid: -1, updateuserid: -1),
                .init(id: 5, name: "Variance", description: "must be between the base plus or minus a variance", createuserid: -1, updateuserid: -1)
            ]
            return cts.map { ct in
                    ct.save(on: database)
                  }
                  .flatten(on: database.eventLoop)
        }
        
        func revert(on database: Database) -> EventLoopFuture<Void> {
            mdlComparisonType.query(on: database).delete()
        }
        
        
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlComparisonType>{
        
        let query = mdlComparisonType.query(on: req.db)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

